/************************************************************************
*                                                                       *
* Nom : mkboot.c                                                        *
* Auteur : Thomas Petazzoni                                             *
* Dernire modification : 5/01/1998                                    *
*                                                                       *
* Description :                                                         *
* Lit un fichier .com, le remplit d'instruction NOP jusqu' temps que   * 
* sa taille soit de 510 octets, puis place le magic number  la fin     *
************************************************************************/


#include <stdio.h>

int makeboot(char *oldname, char *newname);

int main(int argc, char *argv[])
{
	if(argc != 3)
	{
		printf("\nUsage : mkboot src dest");
		printf("\nWhere src is a binary file, and dest is a file which will be 512 bytes in size");
	 	printf("\nThis program has been made to transform a binary file to a valid bootsector");
		return 1;
 	}

	if(makeboot(argv[1], argv[2]) == 0)
 	{		
		puts("\nOperation reussie");
		puts("\nOperation complete");
			return 0;
	}
	else
	{
		fprintf(stderr, "\nError !");
		fprintf(stderr, "\nErreur !");
		return 1;
	}
}

int makeboot(char *oldname, char *newname)

{
	int count = 0;
	FILE *fold, *fnew;
	int c;

	if((fold = fopen(oldname, "rb")) == NULL)
		return -1;

	if((fnew = fopen(newname, "wb")) == NULL)
	{
		fclose(fold);
		return -1;
	}


	for(;!feof(fold);)  
	{ 
		c = fgetc(fold); 
		fputc(c, fnew); 
		count++; 
	} 

	for (c = 144; count < 466; count++) 
		fputc(c, fnew);

	/* add the partition table */ 
	for (c = 0; count < 510; count++) 
		/* not realised yet */ ;

	fputc(170, fnew); 
	fputc(85, fnew); 
	 
	fclose(fnew); 
	fclose(fold); 
 
	return 0;
}
